--Size of Figs :7x4

RasChess._Text = {}

--Table With White Figs
RasChess._Text.White = {}

RasChess._Text.White.Pawn = {
	"  ___  ",
	" (''_) ",
	" /___\\ ",
	"(#____)",
}

RasChess._Text.White.Castle = {
	"XXX",
	"|    |",
	"|    |",
	"|_____|",
}

RasChess._Text.White.Horse = {
	" ____-,",
	"(_o  _(",
	"/_____J",
	"\\#____)",
}

RasChess._Text.White.Bishop = {
	"  _O_  ",
	" ('__) ",
	" (___) ",
	" (___) ",
}

RasChess._Text.White.Queen = {
	"   Q   ",
	"  (_)  ",
	"/___\\",
	"/#____\\",
}

RasChess._Text.White.King = {
	"    ",
	"  /_\\  ",
	"/___\\",
	"/#____\\",
}


--Table With Black Figs
RasChess._Text.Black = {}

RasChess._Text.Black.Pawn = {
	"  ___  ",
	" (''-) ",
	" /\\ ",
	"(#)",
}

RasChess._Text.Black.Castle = {
	"XXX",
	"||",
	"||",
	"|_____|",
}

RasChess._Text.Black.Horse = {
	" ____-,",
	"(_o_(",
	"/J",
	"\\#)",
}

RasChess._Text.Black.Bishop = {
	"  _O_  ",
	" (') ",
	" () ",
	" () ",
}

RasChess._Text.Black.Queen = {
	"   Q   ",
	"  (_)  ",
	"/\\",
	"/#\\",
}

RasChess._Text.Black.King = {
	"    ",
	"  /_\\  ",
	"/\\",
	"/#\\",
}


-- DrawBoard Draws the current Board
-- Awaits as argument the currentgame
-- Returns the Board as "string"

-- For Text Style

-------------------------------------
--		Draw Board
-------------------------------------
RasChess._Text.DrawBoard = function(curgame)

	-- Conversion curgame NumChink to Char
	local ConChinkChar = {
		[1] = "H",
		[2] = "G",
		[3] = "F",
		[4] = "E",
		[5] = "D",
		[6] = "C",
		[7] = "B",
		[8] = "A",
	}

	local nicktop = curgame.sides.Top
	local nickbottom = curgame.sides.Bottom
	local line5 = string.rep(" ",5)
	local ChessBoard = "\r\n\t\t\t[ "..nicktop.." ]  -  WHITE\r\n\r\n\t"..string.rep(" ",8)
	for i = 1,8 do
		ChessBoard = ChessBoard..string.rep(" ",5)..ConChinkChar[i]..string.rep(" ",6)
	end

	ChessBoard = ChessBoard.."\r\n\r\n\t"..string.rep(" ",7)..string.rep("_",97)
	for i = 1,8,2 do
		
		--Draw Begining with Black
		ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",6)..string.char(166)..string.char(166)
		for _ = 1,8 do
			ChessBoard = ChessBoard..string.rep("",11)..string.char(166)
		end
		ChessBoard = ChessBoard..string.char(166)
		for i2 = 1,4 do
			if (i2 == 2) then
				ChessBoard = ChessBoard.."\r\n\t"..i..string.rep(" ",5)..string.char(166)..string.char(166)
			else
				ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",6)..string.char(166)..string.char(166)
			end
			for i3 = 1,8,2 do
				ChessBoard = ChessBoard.." "..RasChess._Text.GetFigsString(curgame[i..i3].ftype,i2,"B").." "..string.char(166).."  "..RasChess._Text.GetFigsString(curgame[i..(i3+1)].ftype,i2,"W").."  "..string.char(166)
			end
			ChessBoard = ChessBoard..string.char(166)
			if (i2 == 2) then
				ChessBoard = ChessBoard..string.rep(" ",5)..i
			end
		end

		--Draw Begining with White
		ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",6)..string.char(166)..string.char(166)
		for _ = 1,8 do
			ChessBoard = ChessBoard..string.rep("",11)..string.char(166)
		end
		ChessBoard = ChessBoard..string.char(166)
		for i2 = 1,4 do
			if (i2 == 2) then
				ChessBoard = ChessBoard.."\r\n\t"..(i+1)..string.rep(" ",5)..string.char(166)..string.char(166)
			else
				ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",6)..string.char(166)..string.char(166)
			end
			for i3 = 1,8,2 do
				ChessBoard = ChessBoard.."  "..RasChess._Text.GetFigsString(curgame[(i+1)..i3].ftype,i2,"W").."  "..string.char(166).." "..RasChess._Text.GetFigsString(curgame[(i+1)..(i3+1)].ftype,i2,"B").." "..string.char(166)
			end
			ChessBoard = ChessBoard..string.char(166)
			if (i2 == 2) then
				ChessBoard = ChessBoard..string.rep(" ",5)..(i+1)
			end
		end

	end
	ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",6)..string.char(166)..string.char(166)
	for _ = 1,8 do
		ChessBoard = ChessBoard..string.rep("",11)..string.char(166)
	end
	ChessBoard = ChessBoard..string.char(166).."\r\n\t"..string.rep(" ",7)..string.rep("",97)

	ChessBoard = ChessBoard.."\r\n\r\n\t"..string.rep(" ",8)
	for i = 1,8 do
		ChessBoard = ChessBoard..string.rep(" ",5)..ConChinkChar[i]..string.rep(" ",6)
	end
	ChessBoard = ChessBoard.."\r\n\r\n\t\t\t[ "..nickbottom.." ]  -  BLACK\r\n"
	return(ChessBoard)
end

-- Get Figures string
RasChess._Text.GetFigsString = function(fig,num,cfield)
	if (fig[2] == "W") then
		return RasChess._Text.White[fig[1]][num]
	elseif (fig[2] == "B") then
		return RasChess._Text.Black[fig[1]][num]
	end
	if (cfield == "W") then
		return ("       ")
	elseif (cfield == "B") then
		return ("")
	end
end

